// Code generated by thriftgo (0.1.7). DO NOT EDIT.

package libo_api

import (
	"bytes"
	"code.byted.org/libo.1220/libo.1220_api/kitex_gen/base"
	"code.byted.org/libo.1220/libo.1220_api/kitex_gen/common_param"
	"code.byted.org/libo.1220/libo.1220_api/kitex_gen/device_info"
	"context"
	"fmt"
	"github.com/apache/thrift/lib/go/thrift"
	"strings"
)

type AgwCommonParam struct {
	Session     *common_param.Session     `thrift:"Session,1" json:"Session"`
	UnifyArgs_  *common_param.UnifyArgs_  `thrift:"UnifyArgs,3" json:"UnifyArgs"`
	CommonArgs_ *common_param.CommonArgs_ `thrift:"CommonArgs,4" json:"CommonArgs"`
	Device      *device_info.Device       `thrift:"Device,7" json:"Device"`
}

func NewAgwCommonParam() *AgwCommonParam {
	return &AgwCommonParam{}
}

var AgwCommonParam_Session_DEFAULT *common_param.Session

func (p *AgwCommonParam) GetSession() (v *common_param.Session) {
	if !p.IsSetSession() {
		return AgwCommonParam_Session_DEFAULT
	}
	return p.Session
}

var AgwCommonParam_UnifyArgs__DEFAULT *common_param.UnifyArgs_

func (p *AgwCommonParam) GetUnifyArgs_() (v *common_param.UnifyArgs_) {
	if !p.IsSetUnifyArgs_() {
		return AgwCommonParam_UnifyArgs__DEFAULT
	}
	return p.UnifyArgs_
}

var AgwCommonParam_CommonArgs__DEFAULT *common_param.CommonArgs_

func (p *AgwCommonParam) GetCommonArgs_() (v *common_param.CommonArgs_) {
	if !p.IsSetCommonArgs_() {
		return AgwCommonParam_CommonArgs__DEFAULT
	}
	return p.CommonArgs_
}

var AgwCommonParam_Device_DEFAULT *device_info.Device

func (p *AgwCommonParam) GetDevice() (v *device_info.Device) {
	if !p.IsSetDevice() {
		return AgwCommonParam_Device_DEFAULT
	}
	return p.Device
}
func (p *AgwCommonParam) SetSession(val *common_param.Session) {
	p.Session = val
}
func (p *AgwCommonParam) SetUnifyArgs_(val *common_param.UnifyArgs_) {
	p.UnifyArgs_ = val
}
func (p *AgwCommonParam) SetCommonArgs_(val *common_param.CommonArgs_) {
	p.CommonArgs_ = val
}
func (p *AgwCommonParam) SetDevice(val *device_info.Device) {
	p.Device = val
}

var fieldIDToName_AgwCommonParam = map[int16]string{
	1: "Session",
	3: "UnifyArgs",
	4: "CommonArgs",
	7: "Device",
}

func (p *AgwCommonParam) IsSetSession() bool {
	return p.Session != nil
}

func (p *AgwCommonParam) IsSetUnifyArgs_() bool {
	return p.UnifyArgs_ != nil
}

func (p *AgwCommonParam) IsSetCommonArgs_() bool {
	return p.CommonArgs_ != nil
}

func (p *AgwCommonParam) IsSetDevice() bool {
	return p.Device != nil
}

func (p *AgwCommonParam) Read(iprot thrift.TProtocol) (err error) {

	var fieldTypeId thrift.TType
	var fieldId int16

	if _, err = iprot.ReadStructBegin(); err != nil {
		goto ReadStructBeginError
	}

	for {
		_, fieldTypeId, fieldId, err = iprot.ReadFieldBegin()
		if err != nil {
			goto ReadFieldBeginError
		}
		if fieldTypeId == thrift.STOP {
			break
		}

		switch fieldId {
		case 1:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField1(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 3:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField3(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 4:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField4(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 7:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField7(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		default:
			if err = iprot.Skip(fieldTypeId); err != nil {
				goto SkipFieldError
			}
		}

		if err = iprot.ReadFieldEnd(); err != nil {
			goto ReadFieldEndError
		}
	}
	if err = iprot.ReadStructEnd(); err != nil {
		goto ReadStructEndError
	}

	return nil
ReadStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read struct begin error: ", p), err)
ReadFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d begin error: ", p, fieldId), err)
ReadFieldError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d '%s' error: ", p, fieldId, fieldIDToName_AgwCommonParam[fieldId]), err)
SkipFieldError:
	return thrift.PrependError(fmt.Sprintf("%T field %d skip type %d error: ", p, fieldId, fieldTypeId), err)

ReadFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T read field end error", p), err)
ReadStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T read struct end error: ", p), err)
}

func (p *AgwCommonParam) ReadField1(iprot thrift.TProtocol) error {
	p.Session = common_param.NewSession()
	if err := p.Session.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *AgwCommonParam) ReadField3(iprot thrift.TProtocol) error {
	p.UnifyArgs_ = common_param.NewUnifyArgs_()
	if err := p.UnifyArgs_.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *AgwCommonParam) ReadField4(iprot thrift.TProtocol) error {
	p.CommonArgs_ = common_param.NewCommonArgs_()
	if err := p.CommonArgs_.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *AgwCommonParam) ReadField7(iprot thrift.TProtocol) error {
	p.Device = device_info.NewDevice()
	if err := p.Device.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *AgwCommonParam) Write(oprot thrift.TProtocol) (err error) {
	var fieldId int16
	if err = oprot.WriteStructBegin("AgwCommonParam"); err != nil {
		goto WriteStructBeginError
	}
	if p != nil {
		if err = p.writeField1(oprot); err != nil {
			fieldId = 1
			goto WriteFieldError
		}
		if err = p.writeField3(oprot); err != nil {
			fieldId = 3
			goto WriteFieldError
		}
		if err = p.writeField4(oprot); err != nil {
			fieldId = 4
			goto WriteFieldError
		}
		if err = p.writeField7(oprot); err != nil {
			fieldId = 7
			goto WriteFieldError
		}

	}
	if err = oprot.WriteFieldStop(); err != nil {
		goto WriteFieldStopError
	}
	if err = oprot.WriteStructEnd(); err != nil {
		goto WriteStructEndError
	}
	return nil
WriteStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write struct begin error: ", p), err)
WriteFieldError:
	return thrift.PrependError(fmt.Sprintf("%T write field %d error: ", p, fieldId), err)
WriteFieldStopError:
	return thrift.PrependError(fmt.Sprintf("%T write field stop error: ", p), err)
WriteStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T write struct end error: ", p), err)
}

func (p *AgwCommonParam) writeField1(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("Session", thrift.STRUCT, 1); err != nil {
		goto WriteFieldBeginError
	}
	if err := p.Session.Write(oprot); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 end error: ", p), err)
}

func (p *AgwCommonParam) writeField3(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("UnifyArgs", thrift.STRUCT, 3); err != nil {
		goto WriteFieldBeginError
	}
	if err := p.UnifyArgs_.Write(oprot); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 3 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 3 end error: ", p), err)
}

func (p *AgwCommonParam) writeField4(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("CommonArgs", thrift.STRUCT, 4); err != nil {
		goto WriteFieldBeginError
	}
	if err := p.CommonArgs_.Write(oprot); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 4 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 4 end error: ", p), err)
}

func (p *AgwCommonParam) writeField7(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("Device", thrift.STRUCT, 7); err != nil {
		goto WriteFieldBeginError
	}
	if err := p.Device.Write(oprot); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 7 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 7 end error: ", p), err)
}

func (p *AgwCommonParam) String() string {
	if p == nil {
		return "<nil>"
	}
	return fmt.Sprintf("AgwCommonParam(%+v)", *p)
}

func (p *AgwCommonParam) DeepEqual(ano *AgwCommonParam) bool {
	if p == ano {
		return true
	} else if p == nil || ano == nil {
		return false
	}
	if !p.Field1DeepEqual(ano.Session) {
		return false
	}
	if !p.Field3DeepEqual(ano.UnifyArgs_) {
		return false
	}
	if !p.Field4DeepEqual(ano.CommonArgs_) {
		return false
	}
	if !p.Field7DeepEqual(ano.Device) {
		return false
	}
	return true
}

func (p *AgwCommonParam) Field1DeepEqual(src *common_param.Session) bool {

	if !p.Session.DeepEqual(src) {
		return false
	}
	return true
}
func (p *AgwCommonParam) Field3DeepEqual(src *common_param.UnifyArgs_) bool {

	if !p.UnifyArgs_.DeepEqual(src) {
		return false
	}
	return true
}
func (p *AgwCommonParam) Field4DeepEqual(src *common_param.CommonArgs_) bool {

	if !p.CommonArgs_.DeepEqual(src) {
		return false
	}
	return true
}
func (p *AgwCommonParam) Field7DeepEqual(src *device_info.Device) bool {

	if !p.Device.DeepEqual(src) {
		return false
	}
	return true
}

type DemoApiReq struct {
	RawBody        []byte              `thrift:"RawBody,1" json:"RawBody"`
	RawUri         string              `thrift:"RawUri,2" json:"RawUri"`
	Headers        map[string][]string `thrift:"Headers,5" json:"Headers"`
	AgwCommonParam *AgwCommonParam     `thrift:"AgwCommonParam,254" json:"AgwCommonParam"`
	Base           *base.Base          `thrift:"Base,255" json:"Base,omitempty"`
}

func NewDemoApiReq() *DemoApiReq {
	return &DemoApiReq{}
}

func (p *DemoApiReq) GetRawBody() (v []byte) {
	return p.RawBody
}

func (p *DemoApiReq) GetRawUri() (v string) {
	return p.RawUri
}

func (p *DemoApiReq) GetHeaders() (v map[string][]string) {
	return p.Headers
}

var DemoApiReq_AgwCommonParam_DEFAULT *AgwCommonParam

func (p *DemoApiReq) GetAgwCommonParam() (v *AgwCommonParam) {
	if !p.IsSetAgwCommonParam() {
		return DemoApiReq_AgwCommonParam_DEFAULT
	}
	return p.AgwCommonParam
}

var DemoApiReq_Base_DEFAULT *base.Base

func (p *DemoApiReq) GetBase() (v *base.Base) {
	if !p.IsSetBase() {
		return DemoApiReq_Base_DEFAULT
	}
	return p.Base
}
func (p *DemoApiReq) SetRawBody(val []byte) {
	p.RawBody = val
}
func (p *DemoApiReq) SetRawUri(val string) {
	p.RawUri = val
}
func (p *DemoApiReq) SetHeaders(val map[string][]string) {
	p.Headers = val
}
func (p *DemoApiReq) SetAgwCommonParam(val *AgwCommonParam) {
	p.AgwCommonParam = val
}
func (p *DemoApiReq) SetBase(val *base.Base) {
	p.Base = val
}

var fieldIDToName_DemoApiReq = map[int16]string{
	1:   "RawBody",
	2:   "RawUri",
	5:   "Headers",
	254: "AgwCommonParam",
	255: "Base",
}

func (p *DemoApiReq) IsSetAgwCommonParam() bool {
	return p.AgwCommonParam != nil
}

func (p *DemoApiReq) IsSetBase() bool {
	return p.Base != nil
}

func (p *DemoApiReq) Read(iprot thrift.TProtocol) (err error) {

	var fieldTypeId thrift.TType
	var fieldId int16

	if _, err = iprot.ReadStructBegin(); err != nil {
		goto ReadStructBeginError
	}

	for {
		_, fieldTypeId, fieldId, err = iprot.ReadFieldBegin()
		if err != nil {
			goto ReadFieldBeginError
		}
		if fieldTypeId == thrift.STOP {
			break
		}

		switch fieldId {
		case 1:
			if fieldTypeId == thrift.STRING {
				if err = p.ReadField1(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 2:
			if fieldTypeId == thrift.STRING {
				if err = p.ReadField2(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 5:
			if fieldTypeId == thrift.MAP {
				if err = p.ReadField5(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 254:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField254(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 255:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField255(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		default:
			if err = iprot.Skip(fieldTypeId); err != nil {
				goto SkipFieldError
			}
		}

		if err = iprot.ReadFieldEnd(); err != nil {
			goto ReadFieldEndError
		}
	}
	if err = iprot.ReadStructEnd(); err != nil {
		goto ReadStructEndError
	}

	return nil
ReadStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read struct begin error: ", p), err)
ReadFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d begin error: ", p, fieldId), err)
ReadFieldError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d '%s' error: ", p, fieldId, fieldIDToName_DemoApiReq[fieldId]), err)
SkipFieldError:
	return thrift.PrependError(fmt.Sprintf("%T field %d skip type %d error: ", p, fieldId, fieldTypeId), err)

ReadFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T read field end error", p), err)
ReadStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T read struct end error: ", p), err)
}

func (p *DemoApiReq) ReadField1(iprot thrift.TProtocol) error {
	if v, err := iprot.ReadBinary(); err != nil {
		return err
	} else {
		p.RawBody = []byte(v)
	}
	return nil
}

func (p *DemoApiReq) ReadField2(iprot thrift.TProtocol) error {
	if v, err := iprot.ReadString(); err != nil {
		return err
	} else {
		p.RawUri = v
	}
	return nil
}

func (p *DemoApiReq) ReadField5(iprot thrift.TProtocol) error {
	_, _, size, err := iprot.ReadMapBegin()
	if err != nil {
		return err
	}
	p.Headers = make(map[string][]string, size)
	for i := 0; i < size; i++ {
		var _key string
		if v, err := iprot.ReadString(); err != nil {
			return err
		} else {
			_key = v
		}

		_, size, err := iprot.ReadListBegin()
		if err != nil {
			return err
		}
		_val := make([]string, 0, size)
		for i := 0; i < size; i++ {
			var _elem string
			if v, err := iprot.ReadString(); err != nil {
				return err
			} else {
				_elem = v
			}

			_val = append(_val, _elem)
		}
		if err := iprot.ReadListEnd(); err != nil {
			return err
		}

		p.Headers[_key] = _val
	}
	if err := iprot.ReadMapEnd(); err != nil {
		return err
	}
	return nil
}

func (p *DemoApiReq) ReadField254(iprot thrift.TProtocol) error {
	p.AgwCommonParam = NewAgwCommonParam()
	if err := p.AgwCommonParam.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *DemoApiReq) ReadField255(iprot thrift.TProtocol) error {
	p.Base = base.NewBase()
	if err := p.Base.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *DemoApiReq) Write(oprot thrift.TProtocol) (err error) {
	var fieldId int16
	if err = oprot.WriteStructBegin("DemoApiReq"); err != nil {
		goto WriteStructBeginError
	}
	if p != nil {
		if err = p.writeField1(oprot); err != nil {
			fieldId = 1
			goto WriteFieldError
		}
		if err = p.writeField2(oprot); err != nil {
			fieldId = 2
			goto WriteFieldError
		}
		if err = p.writeField5(oprot); err != nil {
			fieldId = 5
			goto WriteFieldError
		}
		if err = p.writeField254(oprot); err != nil {
			fieldId = 254
			goto WriteFieldError
		}
		if err = p.writeField255(oprot); err != nil {
			fieldId = 255
			goto WriteFieldError
		}

	}
	if err = oprot.WriteFieldStop(); err != nil {
		goto WriteFieldStopError
	}
	if err = oprot.WriteStructEnd(); err != nil {
		goto WriteStructEndError
	}
	return nil
WriteStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write struct begin error: ", p), err)
WriteFieldError:
	return thrift.PrependError(fmt.Sprintf("%T write field %d error: ", p, fieldId), err)
WriteFieldStopError:
	return thrift.PrependError(fmt.Sprintf("%T write field stop error: ", p), err)
WriteStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T write struct end error: ", p), err)
}

func (p *DemoApiReq) writeField1(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("RawBody", thrift.STRING, 1); err != nil {
		goto WriteFieldBeginError
	}
	if err := oprot.WriteBinary([]byte(p.RawBody)); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 end error: ", p), err)
}

func (p *DemoApiReq) writeField2(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("RawUri", thrift.STRING, 2); err != nil {
		goto WriteFieldBeginError
	}
	if err := oprot.WriteString(p.RawUri); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 2 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 2 end error: ", p), err)
}

func (p *DemoApiReq) writeField5(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("Headers", thrift.MAP, 5); err != nil {
		goto WriteFieldBeginError
	}
	if err := oprot.WriteMapBegin(thrift.STRING, thrift.LIST, len(p.Headers)); err != nil {
		return err
	}
	for k, v := range p.Headers {

		if err := oprot.WriteString(k); err != nil {
			return err
		}

		if err := oprot.WriteListBegin(thrift.STRING, len(v)); err != nil {
			return err
		}
		for _, v := range v {
			if err := oprot.WriteString(v); err != nil {
				return err
			}
		}
		if err := oprot.WriteListEnd(); err != nil {
			return err
		}
	}
	if err := oprot.WriteMapEnd(); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 5 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 5 end error: ", p), err)
}

func (p *DemoApiReq) writeField254(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("AgwCommonParam", thrift.STRUCT, 254); err != nil {
		goto WriteFieldBeginError
	}
	if err := p.AgwCommonParam.Write(oprot); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 254 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 254 end error: ", p), err)
}

func (p *DemoApiReq) writeField255(oprot thrift.TProtocol) (err error) {
	if p.IsSetBase() {
		if err = oprot.WriteFieldBegin("Base", thrift.STRUCT, 255); err != nil {
			goto WriteFieldBeginError
		}
		if err := p.Base.Write(oprot); err != nil {
			return err
		}
		if err = oprot.WriteFieldEnd(); err != nil {
			goto WriteFieldEndError
		}
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 255 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 255 end error: ", p), err)
}

func (p *DemoApiReq) String() string {
	if p == nil {
		return "<nil>"
	}
	return fmt.Sprintf("DemoApiReq(%+v)", *p)
}

func (p *DemoApiReq) DeepEqual(ano *DemoApiReq) bool {
	if p == ano {
		return true
	} else if p == nil || ano == nil {
		return false
	}
	if !p.Field1DeepEqual(ano.RawBody) {
		return false
	}
	if !p.Field2DeepEqual(ano.RawUri) {
		return false
	}
	if !p.Field5DeepEqual(ano.Headers) {
		return false
	}
	if !p.Field254DeepEqual(ano.AgwCommonParam) {
		return false
	}
	if !p.Field255DeepEqual(ano.Base) {
		return false
	}
	return true
}

func (p *DemoApiReq) Field1DeepEqual(src []byte) bool {

	if bytes.Compare(p.RawBody, src) != 0 {
		return false
	}
	return true
}
func (p *DemoApiReq) Field2DeepEqual(src string) bool {

	if strings.Compare(p.RawUri, src) != 0 {
		return false
	}
	return true
}
func (p *DemoApiReq) Field5DeepEqual(src map[string][]string) bool {

	if len(p.Headers) != len(src) {
		return false
	}
	for k, v := range p.Headers {
		_src := src[k]
		if len(v) != len(_src) {
			return false
		}
		for i, v := range v {
			_src1 := _src[i]
			if strings.Compare(v, _src1) != 0 {
				return false
			}
		}
	}
	return true
}
func (p *DemoApiReq) Field254DeepEqual(src *AgwCommonParam) bool {

	if !p.AgwCommonParam.DeepEqual(src) {
		return false
	}
	return true
}
func (p *DemoApiReq) Field255DeepEqual(src *base.Base) bool {

	if !p.Base.DeepEqual(src) {
		return false
	}
	return true
}

type DemoApiResp struct {
	Body     []byte         `thrift:"Body,1,required" json:"Body"`
	BaseResp *base.BaseResp `thrift:"BaseResp,255" json:"BaseResp,omitempty"`
}

func NewDemoApiResp() *DemoApiResp {
	return &DemoApiResp{}
}

func (p *DemoApiResp) GetBody() (v []byte) {
	return p.Body
}

var DemoApiResp_BaseResp_DEFAULT *base.BaseResp

func (p *DemoApiResp) GetBaseResp() (v *base.BaseResp) {
	if !p.IsSetBaseResp() {
		return DemoApiResp_BaseResp_DEFAULT
	}
	return p.BaseResp
}
func (p *DemoApiResp) SetBody(val []byte) {
	p.Body = val
}
func (p *DemoApiResp) SetBaseResp(val *base.BaseResp) {
	p.BaseResp = val
}

var fieldIDToName_DemoApiResp = map[int16]string{
	1:   "Body",
	255: "BaseResp",
}

func (p *DemoApiResp) IsSetBaseResp() bool {
	return p.BaseResp != nil
}

func (p *DemoApiResp) Read(iprot thrift.TProtocol) (err error) {

	var fieldTypeId thrift.TType
	var fieldId int16
	var issetBody bool = false

	if _, err = iprot.ReadStructBegin(); err != nil {
		goto ReadStructBeginError
	}

	for {
		_, fieldTypeId, fieldId, err = iprot.ReadFieldBegin()
		if err != nil {
			goto ReadFieldBeginError
		}
		if fieldTypeId == thrift.STOP {
			break
		}

		switch fieldId {
		case 1:
			if fieldTypeId == thrift.STRING {
				if err = p.ReadField1(iprot); err != nil {
					goto ReadFieldError
				}
				issetBody = true
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		case 255:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField255(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		default:
			if err = iprot.Skip(fieldTypeId); err != nil {
				goto SkipFieldError
			}
		}

		if err = iprot.ReadFieldEnd(); err != nil {
			goto ReadFieldEndError
		}
	}
	if err = iprot.ReadStructEnd(); err != nil {
		goto ReadStructEndError
	}

	if !issetBody {
		fieldId = 1
		goto RequiredFieldNotSetError
	}
	return nil
ReadStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read struct begin error: ", p), err)
ReadFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d begin error: ", p, fieldId), err)
ReadFieldError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d '%s' error: ", p, fieldId, fieldIDToName_DemoApiResp[fieldId]), err)
SkipFieldError:
	return thrift.PrependError(fmt.Sprintf("%T field %d skip type %d error: ", p, fieldId, fieldTypeId), err)

ReadFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T read field end error", p), err)
ReadStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T read struct end error: ", p), err)
RequiredFieldNotSetError:
	return thrift.NewTProtocolExceptionWithType(thrift.INVALID_DATA, fmt.Errorf("required field %s is not set", fieldIDToName_DemoApiResp[fieldId]))
}

func (p *DemoApiResp) ReadField1(iprot thrift.TProtocol) error {
	if v, err := iprot.ReadBinary(); err != nil {
		return err
	} else {
		p.Body = []byte(v)
	}
	return nil
}

func (p *DemoApiResp) ReadField255(iprot thrift.TProtocol) error {
	p.BaseResp = base.NewBaseResp()
	if err := p.BaseResp.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *DemoApiResp) Write(oprot thrift.TProtocol) (err error) {
	var fieldId int16
	if err = oprot.WriteStructBegin("DemoApiResp"); err != nil {
		goto WriteStructBeginError
	}
	if p != nil {
		if err = p.writeField1(oprot); err != nil {
			fieldId = 1
			goto WriteFieldError
		}
		if err = p.writeField255(oprot); err != nil {
			fieldId = 255
			goto WriteFieldError
		}

	}
	if err = oprot.WriteFieldStop(); err != nil {
		goto WriteFieldStopError
	}
	if err = oprot.WriteStructEnd(); err != nil {
		goto WriteStructEndError
	}
	return nil
WriteStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write struct begin error: ", p), err)
WriteFieldError:
	return thrift.PrependError(fmt.Sprintf("%T write field %d error: ", p, fieldId), err)
WriteFieldStopError:
	return thrift.PrependError(fmt.Sprintf("%T write field stop error: ", p), err)
WriteStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T write struct end error: ", p), err)
}

func (p *DemoApiResp) writeField1(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("Body", thrift.STRING, 1); err != nil {
		goto WriteFieldBeginError
	}
	if err := oprot.WriteBinary([]byte(p.Body)); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 end error: ", p), err)
}

func (p *DemoApiResp) writeField255(oprot thrift.TProtocol) (err error) {
	if p.IsSetBaseResp() {
		if err = oprot.WriteFieldBegin("BaseResp", thrift.STRUCT, 255); err != nil {
			goto WriteFieldBeginError
		}
		if err := p.BaseResp.Write(oprot); err != nil {
			return err
		}
		if err = oprot.WriteFieldEnd(); err != nil {
			goto WriteFieldEndError
		}
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 255 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 255 end error: ", p), err)
}

func (p *DemoApiResp) String() string {
	if p == nil {
		return "<nil>"
	}
	return fmt.Sprintf("DemoApiResp(%+v)", *p)
}

func (p *DemoApiResp) DeepEqual(ano *DemoApiResp) bool {
	if p == ano {
		return true
	} else if p == nil || ano == nil {
		return false
	}
	if !p.Field1DeepEqual(ano.Body) {
		return false
	}
	if !p.Field255DeepEqual(ano.BaseResp) {
		return false
	}
	return true
}

func (p *DemoApiResp) Field1DeepEqual(src []byte) bool {

	if bytes.Compare(p.Body, src) != 0 {
		return false
	}
	return true
}
func (p *DemoApiResp) Field255DeepEqual(src *base.BaseResp) bool {

	if !p.BaseResp.DeepEqual(src) {
		return false
	}
	return true
}

type DemoApiService interface {
	SayHi(ctx context.Context, request *DemoApiReq) (r *DemoApiResp, err error)
}

type DemoApiServiceClient struct {
	c thrift.TClient
}

func NewDemoApiServiceClientFactory(t thrift.TTransport, f thrift.TProtocolFactory) *DemoApiServiceClient {
	return &DemoApiServiceClient{
		c: thrift.NewTStandardClient(f.GetProtocol(t), f.GetProtocol(t)),
	}
}

func NewDemoApiServiceClientProtocol(t thrift.TTransport, iprot thrift.TProtocol, oprot thrift.TProtocol) *DemoApiServiceClient {
	return &DemoApiServiceClient{
		c: thrift.NewTStandardClient(iprot, oprot),
	}
}

func NewDemoApiServiceClient(c thrift.TClient) *DemoApiServiceClient {
	return &DemoApiServiceClient{
		c: c,
	}
}

func (p *DemoApiServiceClient) Client_() thrift.TClient {
	return p.c
}

func (p *DemoApiServiceClient) SayHi(ctx context.Context, request *DemoApiReq) (r *DemoApiResp, err error) {
	var _args DemoApiServiceSayHiArgs
	_args.Request = request
	var _result DemoApiServiceSayHiResult
	if err = p.Client_().Call(ctx, "SayHi", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

type DemoApiServiceProcessor struct {
	processorMap map[string]thrift.TProcessorFunction
	handler      DemoApiService
}

func (p *DemoApiServiceProcessor) AddToProcessorMap(key string, processor thrift.TProcessorFunction) {
	p.processorMap[key] = processor
}

func (p *DemoApiServiceProcessor) GetProcessorFunction(key string) (processor thrift.TProcessorFunction, ok bool) {
	processor, ok = p.processorMap[key]
	return processor, ok
}

func (p *DemoApiServiceProcessor) ProcessorMap() map[string]thrift.TProcessorFunction {
	return p.processorMap
}

func NewDemoApiServiceProcessor(handler DemoApiService) *DemoApiServiceProcessor {
	self := &DemoApiServiceProcessor{handler: handler, processorMap: make(map[string]thrift.TProcessorFunction)}
	self.AddToProcessorMap("SayHi", &demoApiServiceProcessorSayHi{handler: handler})
	return self
}
func (p *DemoApiServiceProcessor) Process(ctx context.Context, iprot, oprot thrift.TProtocol) (success bool, err thrift.TException) {
	name, _, seqId, err := iprot.ReadMessageBegin()
	if err != nil {
		return false, err
	}
	if processor, ok := p.GetProcessorFunction(name); ok {
		return processor.Process(ctx, seqId, iprot, oprot)
	}
	iprot.Skip(thrift.STRUCT)
	iprot.ReadMessageEnd()
	x := thrift.NewTApplicationException(thrift.UNKNOWN_METHOD, "Unknown function "+name)
	oprot.WriteMessageBegin(name, thrift.EXCEPTION, seqId)
	x.Write(oprot)
	oprot.WriteMessageEnd()
	oprot.Flush(ctx)
	return false, x
}

type demoApiServiceProcessorSayHi struct {
	handler DemoApiService
}

func (p *demoApiServiceProcessorSayHi) Process(ctx context.Context, seqId int32, iprot, oprot thrift.TProtocol) (success bool, err thrift.TException) {
	args := DemoApiServiceSayHiArgs{}
	if err = args.Read(iprot); err != nil {
		iprot.ReadMessageEnd()
		x := thrift.NewTApplicationException(thrift.PROTOCOL_ERROR, err.Error())
		oprot.WriteMessageBegin("SayHi", thrift.EXCEPTION, seqId)
		x.Write(oprot)
		oprot.WriteMessageEnd()
		oprot.Flush(ctx)
		return false, err
	}

	iprot.ReadMessageEnd()
	var err2 error
	result := DemoApiServiceSayHiResult{}
	var retval *DemoApiResp
	if retval, err2 = p.handler.SayHi(ctx, args.Request); err2 != nil {
		x := thrift.NewTApplicationException(thrift.INTERNAL_ERROR, "Internal error processing SayHi: "+err2.Error())
		oprot.WriteMessageBegin("SayHi", thrift.EXCEPTION, seqId)
		x.Write(oprot)
		oprot.WriteMessageEnd()
		oprot.Flush(ctx)
		return true, err2
	} else {
		result.Success = retval
	}
	if err2 = oprot.WriteMessageBegin("SayHi", thrift.REPLY, seqId); err2 != nil {
		err = err2
	}
	if err2 = result.Write(oprot); err == nil && err2 != nil {
		err = err2
	}
	if err2 = oprot.WriteMessageEnd(); err == nil && err2 != nil {
		err = err2
	}
	if err2 = oprot.Flush(ctx); err == nil && err2 != nil {
		err = err2
	}
	if err != nil {
		return
	}
	return true, err
}

type DemoApiServiceSayHiArgs struct {
	Request *DemoApiReq `thrift:"request,1" json:"request"`
}

func NewDemoApiServiceSayHiArgs() *DemoApiServiceSayHiArgs {
	return &DemoApiServiceSayHiArgs{}
}

var DemoApiServiceSayHiArgs_Request_DEFAULT *DemoApiReq

func (p *DemoApiServiceSayHiArgs) GetRequest() (v *DemoApiReq) {
	if !p.IsSetRequest() {
		return DemoApiServiceSayHiArgs_Request_DEFAULT
	}
	return p.Request
}
func (p *DemoApiServiceSayHiArgs) SetRequest(val *DemoApiReq) {
	p.Request = val
}

var fieldIDToName_DemoApiServiceSayHiArgs = map[int16]string{
	1: "request",
}

func (p *DemoApiServiceSayHiArgs) IsSetRequest() bool {
	return p.Request != nil
}

func (p *DemoApiServiceSayHiArgs) Read(iprot thrift.TProtocol) (err error) {

	var fieldTypeId thrift.TType
	var fieldId int16

	if _, err = iprot.ReadStructBegin(); err != nil {
		goto ReadStructBeginError
	}

	for {
		_, fieldTypeId, fieldId, err = iprot.ReadFieldBegin()
		if err != nil {
			goto ReadFieldBeginError
		}
		if fieldTypeId == thrift.STOP {
			break
		}

		switch fieldId {
		case 1:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField1(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		default:
			if err = iprot.Skip(fieldTypeId); err != nil {
				goto SkipFieldError
			}
		}

		if err = iprot.ReadFieldEnd(); err != nil {
			goto ReadFieldEndError
		}
	}
	if err = iprot.ReadStructEnd(); err != nil {
		goto ReadStructEndError
	}

	return nil
ReadStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read struct begin error: ", p), err)
ReadFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d begin error: ", p, fieldId), err)
ReadFieldError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d '%s' error: ", p, fieldId, fieldIDToName_DemoApiServiceSayHiArgs[fieldId]), err)
SkipFieldError:
	return thrift.PrependError(fmt.Sprintf("%T field %d skip type %d error: ", p, fieldId, fieldTypeId), err)

ReadFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T read field end error", p), err)
ReadStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T read struct end error: ", p), err)
}

func (p *DemoApiServiceSayHiArgs) ReadField1(iprot thrift.TProtocol) error {
	p.Request = NewDemoApiReq()
	if err := p.Request.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *DemoApiServiceSayHiArgs) Write(oprot thrift.TProtocol) (err error) {
	var fieldId int16
	if err = oprot.WriteStructBegin("SayHi_args"); err != nil {
		goto WriteStructBeginError
	}
	if p != nil {
		if err = p.writeField1(oprot); err != nil {
			fieldId = 1
			goto WriteFieldError
		}

	}
	if err = oprot.WriteFieldStop(); err != nil {
		goto WriteFieldStopError
	}
	if err = oprot.WriteStructEnd(); err != nil {
		goto WriteStructEndError
	}
	return nil
WriteStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write struct begin error: ", p), err)
WriteFieldError:
	return thrift.PrependError(fmt.Sprintf("%T write field %d error: ", p, fieldId), err)
WriteFieldStopError:
	return thrift.PrependError(fmt.Sprintf("%T write field stop error: ", p), err)
WriteStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T write struct end error: ", p), err)
}

func (p *DemoApiServiceSayHiArgs) writeField1(oprot thrift.TProtocol) (err error) {
	if err = oprot.WriteFieldBegin("request", thrift.STRUCT, 1); err != nil {
		goto WriteFieldBeginError
	}
	if err := p.Request.Write(oprot); err != nil {
		return err
	}
	if err = oprot.WriteFieldEnd(); err != nil {
		goto WriteFieldEndError
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 1 end error: ", p), err)
}

func (p *DemoApiServiceSayHiArgs) String() string {
	if p == nil {
		return "<nil>"
	}
	return fmt.Sprintf("DemoApiServiceSayHiArgs(%+v)", *p)
}

func (p *DemoApiServiceSayHiArgs) DeepEqual(ano *DemoApiServiceSayHiArgs) bool {
	if p == ano {
		return true
	} else if p == nil || ano == nil {
		return false
	}
	if !p.Field1DeepEqual(ano.Request) {
		return false
	}
	return true
}

func (p *DemoApiServiceSayHiArgs) Field1DeepEqual(src *DemoApiReq) bool {

	if !p.Request.DeepEqual(src) {
		return false
	}
	return true
}

type DemoApiServiceSayHiResult struct {
	Success *DemoApiResp `thrift:"success,0" json:"success,omitempty"`
}

func NewDemoApiServiceSayHiResult() *DemoApiServiceSayHiResult {
	return &DemoApiServiceSayHiResult{}
}

var DemoApiServiceSayHiResult_Success_DEFAULT *DemoApiResp

func (p *DemoApiServiceSayHiResult) GetSuccess() (v *DemoApiResp) {
	if !p.IsSetSuccess() {
		return DemoApiServiceSayHiResult_Success_DEFAULT
	}
	return p.Success
}
func (p *DemoApiServiceSayHiResult) SetSuccess(x interface{}) {
	p.Success = x.(*DemoApiResp)
}

var fieldIDToName_DemoApiServiceSayHiResult = map[int16]string{
	0: "success",
}

func (p *DemoApiServiceSayHiResult) IsSetSuccess() bool {
	return p.Success != nil
}

func (p *DemoApiServiceSayHiResult) Read(iprot thrift.TProtocol) (err error) {

	var fieldTypeId thrift.TType
	var fieldId int16

	if _, err = iprot.ReadStructBegin(); err != nil {
		goto ReadStructBeginError
	}

	for {
		_, fieldTypeId, fieldId, err = iprot.ReadFieldBegin()
		if err != nil {
			goto ReadFieldBeginError
		}
		if fieldTypeId == thrift.STOP {
			break
		}

		switch fieldId {
		case 0:
			if fieldTypeId == thrift.STRUCT {
				if err = p.ReadField0(iprot); err != nil {
					goto ReadFieldError
				}
			} else {
				if err = iprot.Skip(fieldTypeId); err != nil {
					goto SkipFieldError
				}
			}
		default:
			if err = iprot.Skip(fieldTypeId); err != nil {
				goto SkipFieldError
			}
		}

		if err = iprot.ReadFieldEnd(); err != nil {
			goto ReadFieldEndError
		}
	}
	if err = iprot.ReadStructEnd(); err != nil {
		goto ReadStructEndError
	}

	return nil
ReadStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read struct begin error: ", p), err)
ReadFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d begin error: ", p, fieldId), err)
ReadFieldError:
	return thrift.PrependError(fmt.Sprintf("%T read field %d '%s' error: ", p, fieldId, fieldIDToName_DemoApiServiceSayHiResult[fieldId]), err)
SkipFieldError:
	return thrift.PrependError(fmt.Sprintf("%T field %d skip type %d error: ", p, fieldId, fieldTypeId), err)

ReadFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T read field end error", p), err)
ReadStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T read struct end error: ", p), err)
}

func (p *DemoApiServiceSayHiResult) ReadField0(iprot thrift.TProtocol) error {
	p.Success = NewDemoApiResp()
	if err := p.Success.Read(iprot); err != nil {
		return err
	}
	return nil
}

func (p *DemoApiServiceSayHiResult) Write(oprot thrift.TProtocol) (err error) {
	var fieldId int16
	if err = oprot.WriteStructBegin("SayHi_result"); err != nil {
		goto WriteStructBeginError
	}
	if p != nil {
		if err = p.writeField0(oprot); err != nil {
			fieldId = 0
			goto WriteFieldError
		}

	}
	if err = oprot.WriteFieldStop(); err != nil {
		goto WriteFieldStopError
	}
	if err = oprot.WriteStructEnd(); err != nil {
		goto WriteStructEndError
	}
	return nil
WriteStructBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write struct begin error: ", p), err)
WriteFieldError:
	return thrift.PrependError(fmt.Sprintf("%T write field %d error: ", p, fieldId), err)
WriteFieldStopError:
	return thrift.PrependError(fmt.Sprintf("%T write field stop error: ", p), err)
WriteStructEndError:
	return thrift.PrependError(fmt.Sprintf("%T write struct end error: ", p), err)
}

func (p *DemoApiServiceSayHiResult) writeField0(oprot thrift.TProtocol) (err error) {
	if p.IsSetSuccess() {
		if err = oprot.WriteFieldBegin("success", thrift.STRUCT, 0); err != nil {
			goto WriteFieldBeginError
		}
		if err := p.Success.Write(oprot); err != nil {
			return err
		}
		if err = oprot.WriteFieldEnd(); err != nil {
			goto WriteFieldEndError
		}
	}
	return nil
WriteFieldBeginError:
	return thrift.PrependError(fmt.Sprintf("%T write field 0 begin error: ", p), err)
WriteFieldEndError:
	return thrift.PrependError(fmt.Sprintf("%T write field 0 end error: ", p), err)
}

func (p *DemoApiServiceSayHiResult) String() string {
	if p == nil {
		return "<nil>"
	}
	return fmt.Sprintf("DemoApiServiceSayHiResult(%+v)", *p)
}

func (p *DemoApiServiceSayHiResult) DeepEqual(ano *DemoApiServiceSayHiResult) bool {
	if p == ano {
		return true
	} else if p == nil || ano == nil {
		return false
	}
	if !p.Field0DeepEqual(ano.Success) {
		return false
	}
	return true
}

func (p *DemoApiServiceSayHiResult) Field0DeepEqual(src *DemoApiResp) bool {

	if !p.Success.DeepEqual(src) {
		return false
	}
	return true
}
